;; -*- geiser-scheme-implementation: guile -*-

;; hooks.scm - This file is part of Guile TD
;; Copyright (C) 2017  Christopher Howard

;; Guile TD is free software: you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation, either version 3 of the License, or
;; (at your option) any later version.

;; Guile TD is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
;; General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.

(define-module (td hooks)
  :export (add-hook-once-only!
           new-game-hook
           field-crossed
           game-fail
           game-victory-hook))

(define (add-hook-once-only! hook proc)
   (letrec ((proc-once-only
             (lambda args
               (remove-hook! hook proc-once-only)
               (apply proc args))))
     (add-hook! hook proc-once-only)))

(define new-game-hook (make-hook))

(define field-crossed (make-hook))

(define game-fail (make-hook))

(define game-victory-hook (make-hook))
