;; -*- geiser-scheme-implementation: guile -*-

;; guile-td.scm - This file is part of Guile TD
;; Copyright (C) 2017  Christopher Howard

;; Guile TD is free software: you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation, either version 3 of the License, or
;; (at your option) any later version.

;; Guile TD is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
;; General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.

(define-module (td main)
  #:use-module (td bullet)
  #:use-module (td credits)
  #:use-module (td enemy)
  #:use-module (td gfx)
  #:use-module (td interface)
  #:use-module (td level)
  #:use-module (td tick)
  #:use-module (td tower)
  #:export (start-td))

(use-modules (chickadee)
             (system repl server)
             (system repl coop-server))

(read-set! keywords 'prefix)

(define (start-td)

  (let* ((server-socket (make-tcp-server-socket))
         (coop-server (spawn-coop-repl-server server-socket)))
    
    (add-hook! update-hook
               (lambda (dt)
                 (poll-coop-repl-server coop-server)))
    
    (add-hook! quit-hook (lambda () (abort-game)))
    
    (run-game :window-title "Guile TD"
              :window-width 1024
              :window-height 768
              :update-hz (truncate-quotient 1000 period))

    (stop-server-and-clients!)))
