;; -*- geiser-scheme-implementation: guile -*-

;; tick.scm - This file is part of Guile TD
;; Copyright (C) 2017  Christopher Howard

;; Guile TD is free software: you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation, either version 3 of the License, or
;; (at your option) any later version.

;; Guile TD is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
;; General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.

(define-module (td tick)
  :use-module (td hooks)
  :use-module (chickadee)
  :use-module (chickadee scripting)
  :export (period
           pause-game
           unpause-game
           game-paused?))
           
;; milliseconds between game ticks
(define period 50)

(define game-paused #f)

(add-hook! update-hook
           (lambda (dt)
             (if (not game-paused)
                 (update-agenda period))))

(define (pause-game)
  (set! game-paused #t))

(define (unpause-game)
  (set! game-paused #f))

(define (game-paused?)
  game-paused)

(add-hook! new-game-hook
           (lambda ()
             (unpause-game)))

(add-hook! game-victory-hook
           (lambda ()
             (pause-game)))
